Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/AdministratorMenuItem.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/AdministratorMenuItem.cs	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/AdministratorMenuItem.cs	(revision 4548)
@@ -37,5 +37,5 @@
 
     public override void Execute() {
-      MainFormManager.MainForm.ShowContent(Administrator.Instance);
+      MainFormManager.MainForm.ShowContent(OKB.Instance);
     }
   }
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 4548)
@@ -47,4 +47,7 @@
     <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Core.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Data-3.3">
+      <HintPath>..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Data-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.MainForm-3.3">
       <HintPath>..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm-3.3.dll</HintPath>
@@ -73,11 +76,9 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Administrator.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="AdministratorMenuItem.cs" />
+    <Compile Include="OKB.cs" />
+    <Compile Include="OKBExperiment.cs" />
     <Compile Include="HeuristicLabClientsOKBPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="ServiceClients\AdminServiceClient.cs" />
     <Compile Include="ServiceClients\Algorithm.cs">
       <SubType>Code</SubType>
@@ -88,4 +89,5 @@
     <Compile Include="ServiceClients\AuthenticationServiceClient.cs" />
     <Compile Include="ServiceClients\AlgorithmData.cs" />
+    <Compile Include="ServiceClients\OKBServiceClient.cs" />
     <Compile Include="ServiceClients\ProblemData.cs" />
     <Compile Include="ServiceClients\Problem.cs" />
@@ -132,4 +134,10 @@
     <Compile Include="Views\AlgorithmDataView.Designer.cs">
       <DependentUpon>AlgorithmDataView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Views\OKBExperimentView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\OKBExperimentView.Designer.cs">
+      <DependentUpon>OKBExperimentView.cs</DependentUpon>
     </Compile>
     <Compile Include="Views\ProblemDataView.cs">
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLabClientsOKBPlugin.cs.frame
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLabClientsOKBPlugin.cs.frame	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLabClientsOKBPlugin.cs.frame	(revision 4548)
@@ -34,4 +34,5 @@
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/OKB.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/OKB.cs	(revision 4548)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/OKB.cs	(revision 4548)
@@ -0,0 +1,366 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Clients.Common;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Clients.OKB {
+  [Item("OKB", "OKB front-end.")]
+  public sealed class OKB : IContent {
+    private static OKB instance;
+    public static OKB Instance {
+      get {
+        if (instance == null) instance = new OKB();
+        return instance;
+      }
+    }
+
+    #region Properties
+    private ItemCollection<Platform> platforms;
+    public ItemCollection<Platform> Platforms {
+      get { return platforms; }
+    }
+    private ItemCollection<DataType> dataTypes;
+    public ItemCollection<DataType> DataTypes {
+      get { return dataTypes; }
+    }
+    private IEnumerable<User> users;
+    public IEnumerable<User> Users {
+      get { return users; }
+    }
+    private ItemCollection<AlgorithmClass> algorithmClasses;
+    public ItemCollection<AlgorithmClass> AlgorithmClasses {
+      get { return algorithmClasses; }
+    }
+    private ItemCollection<Algorithm> algorithms;
+    public ItemCollection<Algorithm> Algorithms {
+      get { return algorithms; }
+    }
+    private ItemCollection<ProblemClass> problemClasses;
+    public ItemCollection<ProblemClass> ProblemClasses {
+      get { return problemClasses; }
+    }
+    private ItemCollection<Problem> problems;
+    public ItemCollection<Problem> Problems {
+      get { return problems; }
+    }
+    #endregion
+
+    private OKB() { }
+
+    #region Refresh
+    public void Refresh() {
+      OnRefreshing();
+      if (platforms == null) {
+        platforms = new ItemCollection<Platform>();
+        platforms.ItemsRemoved += new CollectionItemsChangedEventHandler<Platform>(platforms_ItemsRemoved);
+      }
+      platforms.Clear();
+      if (dataTypes == null) {
+        dataTypes = new ItemCollection<DataType>();
+        dataTypes.ItemsRemoved += new CollectionItemsChangedEventHandler<DataType>(dataTypes_ItemsRemoved);
+      }
+      dataTypes.Clear();
+      if (algorithmClasses == null) {
+        algorithmClasses = new ItemCollection<AlgorithmClass>();
+        algorithmClasses.ItemsRemoved += new CollectionItemsChangedEventHandler<AlgorithmClass>(algorithmClasses_ItemsRemoved);
+      }
+      algorithmClasses.Clear();
+      if (algorithms == null) {
+        algorithms = new ItemCollection<Algorithm>();
+        algorithms.ItemsRemoved += new CollectionItemsChangedEventHandler<Algorithm>(algorithms_ItemsRemoved);
+      }
+      algorithms.Clear();
+      if (problemClasses == null) {
+        problemClasses = new ItemCollection<ProblemClass>();
+        problemClasses.ItemsRemoved += new CollectionItemsChangedEventHandler<ProblemClass>(problemClasses_ItemsRemoved);
+      }
+      problemClasses.Clear();
+      if (problems == null) {
+        problems = new ItemCollection<Problem>();
+        problems.ItemsRemoved += new CollectionItemsChangedEventHandler<Problem>(problems_ItemsRemoved);
+      }
+      problems.Clear();
+
+      var call = new Func<Exception>(delegate() {
+        try {
+          platforms.AddRange(CallAdminService<Platform[]>(s => s.GetPlatforms()).OrderBy(x => x.Name));
+          dataTypes.AddRange(CallAdminService<DataType[]>(s => s.GetDataTypes()).OrderBy(x => x.Name));
+          users = CallAuthenticationService<User[]>(s => s.GetUsers()).OrderBy(x => x.Name);
+          algorithmClasses.AddRange(CallAdminService<AlgorithmClass[]>(s => s.GetAlgorithmClasses()).OrderBy(x => x.Name));
+          algorithms.AddRange(CallAdminService<Algorithm[]>(s => s.GetAlgorithms()).OrderBy(x => x.Name));
+          problemClasses.AddRange(CallAdminService<ProblemClass[]>(s => s.GetProblemClasses()).OrderBy(x => x.Name));
+          problems.AddRange(CallAdminService<Problem[]>(s => s.GetProblems()).OrderBy(x => x.Name));
+          return null;
+        }
+        catch (Exception ex) {
+          return ex;
+        }
+      });
+      call.BeginInvoke(delegate(IAsyncResult result) {
+        Exception ex = call.EndInvoke(result);
+        if (ex != null) ErrorHandling.ShowErrorDialog("Refresh failed.", ex);
+        OnRefreshed();
+      }, null);
+    }
+    #endregion
+
+    #region Store
+    public bool Store(IOKBItem item) {
+      try {
+        if (item.Id == 0) {
+          if (item is Platform)
+            item.Id = CallAdminService<long>(s => s.AddPlatform((Platform)item));
+          else if (item is DataType)
+            item.Id = CallAdminService<long>(s => s.AddDataType((DataType)item));
+          else if (item is AlgorithmClass)
+            item.Id = CallAdminService<long>(s => s.AddAlgorithmClass((AlgorithmClass)item));
+          else if (item is Algorithm)
+            item.Id = CallAdminService<long>(s => s.AddAlgorithm((Algorithm)item));
+          else if (item is ProblemClass)
+            item.Id = CallAdminService<long>(s => s.AddProblemClass((ProblemClass)item));
+          else if (item is Problem)
+            item.Id = CallAdminService<long>(s => s.AddProblem((Problem)item));
+        } else {
+          if (item is Platform)
+            CallAdminService(s => s.UpdatePlatform((Platform)item));
+          else if (item is DataType)
+            CallAdminService(s => s.UpdateDataType((DataType)item));
+          else if (item is AlgorithmClass)
+            CallAdminService(s => s.UpdateAlgorithmClass((AlgorithmClass)item));
+          else if (item is Algorithm)
+            CallAdminService(s => s.UpdateAlgorithm((Algorithm)item));
+          else if (item is ProblemClass)
+            CallAdminService(s => s.UpdateProblemClass((ProblemClass)item));
+          else if (item is Problem)
+            CallAdminService(s => s.UpdateProblem((Problem)item));
+        }
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Store failed.", ex);
+        return false;
+      }
+    }
+    #endregion
+
+    #region Algorithm Methods
+    public Guid[] GetAlgorithmUsers(long algorithmId) {
+      try {
+        return CallAdminService<Guid[]>(s => s.GetAlgorithmUsers(algorithmId));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh authorized algorithm users failed.", ex);
+        return null;
+      }
+    }
+    public bool UpdateAlgorithmUsers(long algorithmId, Guid[] users) {
+      try {
+        CallAdminService(s => s.UpdateAlgorithmUsers(algorithmId, users));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update authorized algorithm users failed.", ex);
+        return false;
+      }
+    }
+    public AlgorithmData GetAlgorithmData(long algorithmId) {
+      try {
+        return CallAdminService<AlgorithmData>(s => s.GetAlgorithmData(algorithmId));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh algorithm data failed.", ex);
+        return null;
+      }
+    }
+    public bool UpdateAlgorithmData(AlgorithmData algorithmData) {
+      try {
+        CallAdminService(s => s.UpdateAlgorithmData(algorithmData));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update algorithm data failed.", ex);
+        return false;
+      }
+    }
+    #endregion
+
+    #region Problem Methods
+    public Guid[] GetProblemUsers(long problemId) {
+      try {
+        return CallAdminService<Guid[]>(s => s.GetProblemUsers(problemId));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh authorized problem users failed.", ex);
+        return null;
+      }
+    }
+    public bool UpdateProblemUsers(long problemId, Guid[] users) {
+      try {
+        CallAdminService(s => s.UpdateProblemUsers(problemId, users));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update authorized problem users failed.", ex);
+        return false;
+      }
+    }
+    public ProblemData GetProblemData(long problemId) {
+      try {
+        return CallAdminService<ProblemData>(s => s.GetProblemData(problemId));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh problem data failed.", ex);
+        return null;
+      }
+    }
+    public bool UpdateProblemData(ProblemData problemData) {
+      try {
+        CallAdminService(s => s.UpdateProblemData(problemData));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update problem data failed.", ex);
+        return false;
+      }
+    }
+    #endregion
+
+    #region Events
+    public event EventHandler Refreshing;
+    private void OnRefreshing() {
+      EventHandler handler = Refreshing;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler Refreshed;
+    private void OnRefreshed() {
+      EventHandler handler = Refreshed;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    private void platforms_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<Platform> e) {
+      try {
+        foreach (Platform p in e.Items)
+          CallAdminService(s => s.DeletePlatform(p.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    private void dataTypes_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<DataType> e) {
+      try {
+        foreach (DataType d in e.Items)
+          CallAdminService(s => s.DeleteDataType(d.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    private void algorithmClasses_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<AlgorithmClass> e) {
+      try {
+        foreach (AlgorithmClass a in e.Items)
+          CallAdminService(s => s.DeleteAlgorithmClass(a.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    private void algorithms_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<Algorithm> e) {
+      try {
+        foreach (Algorithm a in e.Items)
+          CallAdminService(s => s.DeleteAlgorithm(a.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    private void problemClasses_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<ProblemClass> e) {
+      try {
+        foreach (ProblemClass p in e.Items)
+          CallAdminService(s => s.DeleteProblemClass(p.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    private void problems_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<Problem> e) {
+      try {
+        foreach (Problem p in e.Items)
+          CallAdminService(s => s.DeleteProblem(p.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    #endregion
+
+    #region Helpers
+    private void CallAdminService(Action<IOKBService> call) {
+      OKBServiceClient client = ClientFactory.CreateClient<OKBServiceClient, IOKBService>();
+      try {
+        call(client);
+      }
+      finally {
+        try {
+          client.Close();
+        }
+        catch (Exception) {
+          client.Abort();
+        }
+      }
+    }
+    private T CallAdminService<T>(Func<IOKBService, T> call) {
+      OKBServiceClient client = ClientFactory.CreateClient<OKBServiceClient, IOKBService>();
+      try {
+        return call(client);
+      }
+      finally {
+        try {
+          client.Close();
+        }
+        catch (Exception) {
+          client.Abort();
+        }
+      }
+    }
+    private T CallAuthenticationService<T>(Func<IAuthenticationService, T> call) {
+      AuthenticationServiceClient client = ClientFactory.CreateClient<AuthenticationServiceClient, IAuthenticationService>();
+      try {
+        return call(client);
+      }
+      finally {
+        try {
+          client.Close();
+        }
+        catch (Exception) {
+          client.Abort();
+        }
+      }
+    }
+    #endregion
+  }
+}
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/OKBExperiment.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/OKBExperiment.cs	(revision 4548)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/OKBExperiment.cs	(revision 4548)
@@ -0,0 +1,124 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Common;
+using System.Drawing;
+
+namespace HeuristicLab.Clients.OKB {
+  [Creatable("OKB")]
+  [Item("OKB Experiment", "...")]
+  public sealed class OKBExperiment : NamedItem, IOptimizer, IStorableContent {
+    public string Filename { get; set; }
+
+    public override Image ItemImage {
+      get {
+        if (ExecutionState == ExecutionState.Prepared) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePrepared;
+        else if (ExecutionState == ExecutionState.Started) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStarted;
+        else if (ExecutionState == ExecutionState.Paused) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePaused;
+        else if (ExecutionState == ExecutionState.Stopped) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
+        else return HeuristicLab.Common.Resources.VS2008ImageLibrary.Event;
+      }
+    }
+
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public override bool CanChangeDescription {
+      get { return false; }
+    }
+
+    private IAlgorithm algorithm;
+    private IAlgorithm Algorithm {
+      get { return algorithm; }
+      set { algorithm = value; }
+    }
+    private IProblem problem;
+    private IProblem Problem {
+      get { return problem; }
+      set { problem = value; }
+    }
+
+    public void LoadAlgorithm(long algorithmId) {
+
+    }
+    public void LoadProblem(long problemId) {
+
+    }
+
+
+
+    #region IOptimizer Members
+
+    public void Prepare(bool clearRuns) {
+      throw new System.NotImplementedException();
+    }
+
+    public RunCollection Runs {
+      get { throw new System.NotImplementedException(); }
+    }
+
+    #endregion
+
+    #region IExecutable Members
+
+    public event System.EventHandler<EventArgs<System.Exception>> ExceptionOccurred;
+
+    public ExecutionState ExecutionState {
+      get { throw new System.NotImplementedException(); }
+    }
+
+    public event System.EventHandler ExecutionStateChanged;
+
+    public System.TimeSpan ExecutionTime {
+      get { throw new System.NotImplementedException(); }
+    }
+
+    public event System.EventHandler ExecutionTimeChanged;
+
+    public void Pause() {
+      throw new System.NotImplementedException();
+    }
+
+    public event System.EventHandler Paused;
+
+    public void Prepare() {
+      throw new System.NotImplementedException();
+    }
+
+    public event System.EventHandler Prepared;
+
+    public void Start() {
+      throw new System.NotImplementedException();
+    }
+
+    public event System.EventHandler Started;
+
+    public void Stop() {
+      throw new System.NotImplementedException();
+    }
+
+    public event System.EventHandler Stopped;
+
+    #endregion
+  }
+}
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/ServiceClients/GenerateServiceClients.cmd
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/ServiceClients/GenerateServiceClients.cmd	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/ServiceClients/GenerateServiceClients.cmd	(revision 4548)
@@ -3,10 +3,10 @@
 echo.
 echo *******************************************************************************************
-echo Generating AdminService client
+echo Generating OKBService client
 echo.
 
 svcutil.exe ^
-  http://localhost:8732/Design_Time_Addresses/OKB-3.3/AdminService/mex ^
-  /out:AdminServiceClient ^
+  http://localhost:8732/Design_Time_Addresses/OKB-3.3/OKBService/mex ^
+  /out:OKBServiceClient ^
   /namespace:*,HeuristicLab.Clients.OKB ^
   /targetClientVersion:Version35 ^
@@ -24,5 +24,5 @@
 echo ---------------------------------------------------------------------------------------
 echo.
-echo Generation of AdminService client finished.
+echo Generation of OKBService client finished.
 echo *******************************************************************************************
 echo.
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/ServiceClients/OKBItem.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/ServiceClients/OKBItem.cs	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/ServiceClients/OKBItem.cs	(revision 4548)
@@ -86,5 +86,5 @@
 
     public void Store() {
-      if (Administrator.Instance.Store(this))
+      if (OKB.Instance.Store(this))
         Modified = false;
     }
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AdministratorView.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AdministratorView.cs	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AdministratorView.cs	(revision 4548)
@@ -27,8 +27,8 @@
 namespace HeuristicLab.Clients.OKB {
   [View("OKB Administrator")]
-  [Content(typeof(Administrator), true)]
+  [Content(typeof(OKB), true)]
   public sealed partial class AdministratorView : AsynchronousContentView {
-    public new Administrator Content {
-      get { return (Administrator)base.Content; }
+    public new OKB Content {
+      get { return (OKB)base.Content; }
       set { base.Content = value; }
     }
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmDataView.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmDataView.cs	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmDataView.cs	(revision 4548)
@@ -60,5 +60,5 @@
     protected override void OnInitialized(System.EventArgs e) {
       base.OnInitialized(e);
-      dataTypeComboBox.DataSource = Administrator.Instance.DataTypes.ToList();
+      dataTypeComboBox.DataSource = OKB.Instance.DataTypes.ToList();
       dataTypeComboBox.SelectedIndex = -1;
     }
@@ -80,5 +80,5 @@
         noViewAvailableLabel.Visible = false;
       } else {
-        dataTypeComboBox.SelectedItem = Administrator.Instance.DataTypes.FirstOrDefault(d => d.Id == Content.DataTypeId);
+        dataTypeComboBox.SelectedItem = OKB.Instance.DataTypes.FirstOrDefault(d => d.Id == Content.DataTypeId);
 
         using (MemoryStream stream = new MemoryStream(Content.Data)) {
@@ -111,5 +111,5 @@
       switch (e.PropertyName) {
         case "DataTypeId":
-          dataTypeComboBox.SelectedItem = Administrator.Instance.DataTypes.FirstOrDefault(d => d.Id == Content.DataTypeId);
+          dataTypeComboBox.SelectedItem = OKB.Instance.DataTypes.FirstOrDefault(d => d.Id == Content.DataTypeId);
           break;
       }
@@ -119,5 +119,5 @@
       BeginAsyncCall();
       var call = new Action(delegate() {
-        AlgorithmData data = Administrator.Instance.GetAlgorithmData(AlgorithmId);
+        AlgorithmData data = OKB.Instance.GetAlgorithmData(AlgorithmId);
         Content = data;
       });
@@ -142,5 +142,5 @@
         }
       }
-      Administrator.Instance.UpdateAlgorithmData(Content);
+      OKB.Instance.UpdateAlgorithmData(Content);
     }
     private void newDataButton_Click(object sender, EventArgs e) {
@@ -153,11 +153,11 @@
             if (Content == null) Content = new AlgorithmData { AlgorithmId = AlgorithmId };
             viewHost.Content = (IContent)dialog.TypeSelector.CreateInstanceOfSelectedType();
-            DataType dataType = Administrator.Instance.DataTypes.FirstOrDefault(d => d.Name == viewHost.Content.GetType().AssemblyQualifiedName);
+            DataType dataType = OKB.Instance.DataTypes.FirstOrDefault(d => d.Name == viewHost.Content.GetType().AssemblyQualifiedName);
             if (dataType == null) {
               dataType = new DataType { Name = viewHost.Content.GetType().AssemblyQualifiedName, SqlName = "varbinary" };
-              dataType.PlatformId = Administrator.Instance.Platforms.FirstOrDefault(p => p.Name == "HeuristicLab 3.3").Id;
+              dataType.PlatformId = OKB.Instance.Platforms.FirstOrDefault(p => p.Name == "HeuristicLab 3.3").Id;
               dataType.Store();
-              Administrator.Instance.DataTypes.Add(dataType);
-              dataTypeComboBox.DataSource = Administrator.Instance.DataTypes.OrderBy(d => d.Name).ToList();
+              OKB.Instance.DataTypes.Add(dataType);
+              dataTypeComboBox.DataSource = OKB.Instance.DataTypes.OrderBy(d => d.Name).ToList();
             }
             dataTypeComboBox.SelectedItem = dataType;
@@ -185,11 +185,11 @@
             viewHost.Content = algorithm;
             noViewAvailableLabel.Visible = false;
-            DataType dataType = Administrator.Instance.DataTypes.FirstOrDefault(d => d.Name == viewHost.Content.GetType().AssemblyQualifiedName);
+            DataType dataType = OKB.Instance.DataTypes.FirstOrDefault(d => d.Name == viewHost.Content.GetType().AssemblyQualifiedName);
             if (dataType == null) {
               dataType = new DataType { Name = viewHost.Content.GetType().AssemblyQualifiedName, SqlName = "varbinary" };
-              dataType.PlatformId = Administrator.Instance.Platforms.FirstOrDefault(p => p.Name == "HeuristicLab 3.3").Id;
+              dataType.PlatformId = OKB.Instance.Platforms.FirstOrDefault(p => p.Name == "HeuristicLab 3.3").Id;
               dataType.Store();
-              Administrator.Instance.DataTypes.Add(dataType);
-              dataTypeComboBox.DataSource = Administrator.Instance.DataTypes.OrderBy(d => d.Name).ToList();
+              OKB.Instance.DataTypes.Add(dataType);
+              dataTypeComboBox.DataSource = OKB.Instance.DataTypes.OrderBy(d => d.Name).ToList();
             }
             dataTypeComboBox.SelectedItem = dataType;
Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.cs	(revision 4539)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.cs	(revision 4548)
@@ -42,6 +42,6 @@
     protected override void OnInitialized(System.EventArgs e) {
       base.OnInitialized(e);
-      platformComboBox.DataSource = Administrator.Instance.Platforms.ToList();
-      algorithmClassComboBox.DataSource = Administrator.Instance.AlgorithmClasses.ToList();
+      platformComboBox.DataSource = OKB.Instance.Platforms.ToList();
+      algorithmClassComboBox.DataSource = OKB.Instance.AlgorithmClasses.ToList();
     }
 
@@ -53,6 +53,6 @@
         algorithmDataView.AlgorithmId = 0;
       } else {
-        platformComboBox.SelectedItem = Administrator.Instance.Platforms.FirstOrDefault(p => p.Id == Content.PlatformId);
-        algorithmClassComboBox.SelectedItem = Administrator.Instance.AlgorithmClasses.FirstOrDefault(a => a.Id == Content.AlgorithmClassId);
+        platformComboBox.SelectedItem = OKB.Instance.Platforms.FirstOrDefault(p => p.Id == Content.PlatformId);
+        algorithmClassComboBox.SelectedItem = OKB.Instance.AlgorithmClasses.FirstOrDefault(a => a.Id == Content.AlgorithmClassId);
         algorithmDataView.AlgorithmId = Content.Id;
       }
@@ -77,8 +77,8 @@
           break;
         case "PlatformId":
-          platformComboBox.SelectedItem = Administrator.Instance.Platforms.FirstOrDefault(p => p.Id == Content.PlatformId);
+          platformComboBox.SelectedItem = OKB.Instance.Platforms.FirstOrDefault(p => p.Id == Content.PlatformId);
           break;
         case "AlgorithmClassId":
-          algorithmClassComboBox.SelectedItem = Administrator.Instance.AlgorithmClasses.FirstOrDefault(a => a.Id == Content.AlgorithmClassId);
+          algorithmClassComboBox.SelectedItem = OKB.Instance.AlgorithmClasses.FirstOrDefault(a => a.Id == Content.AlgorithmClassId);
           break;
       }
@@ -99,7 +99,7 @@
 
     private void refreshUsersButton_Click(object sender, System.EventArgs e) {
-      Guid[] ids = Administrator.Instance.GetAlgorithmUsers(Content.Id);
+      Guid[] ids = OKB.Instance.GetAlgorithmUsers(Content.Id);
       if (ids != null) {
-        List<User> users = Administrator.Instance.Users.ToList();
+        List<User> users = OKB.Instance.Users.ToList();
         usersListBox.DataSource = users;
         usersListBox.DisplayMember = "Name";
@@ -112,5 +112,5 @@
     }
     private void storeUsersButton_Click(object sender, System.EventArgs e) {
-      if (Administrator.Instance.UpdateAlgorithmUsers(Content.Id, usersListBox.SelectedItems.Cast<User>().Select(u => u.Id).ToArray()))
+      if (OKB.Instance.UpdateAlgorithmUsers(Content.Id, usersListBox.SelectedItems.Cast<User>().Select(u => u.Id).ToArray()))
         storeUsersButton.Enabled = false;
     }
